module PixivApi
  module Request
    module FavoriteUsers
      def favorite_users(*args)
        objects_from_response(Response::User, :get, '/v1/me/favorite-users.json', args.extract_options!)
      end

      def delete_favorite_users(user_ids: [], **args)
        options = args.deep_merge(params: { delete_ids: user_ids.join(',') })
        action_from_response(:delete, '/v1/me/favorite-users.json', options)
      end

      def favorite_user(user_id:, publicity:, **args)
        options = args.deep_merge(params: { target_user_id: user_id, publicity: publicity })
        action_from_response(:post, '/v1/me/favorite-users.json', options)
      end
    end
  end
end
