require 'mime/types'

module PixivApi
  module Request
    module UploadWork
      def upload(files:, type:, age_limit:, sexual:, **args)
        options = {
          body: args.merge(
            {
              type: type,
              age_limit: age_limit,
              sexual: sexual,
              files: files,
            }
          )
        }

        object_from_response(Response::UploadToken, :post, '/v1/upload/works', options)
      end

      def upload_status(upload_token:)
        options = { params: { upload_token: upload_token } }
        object_from_response(Response::UploadStatus, :get, "/v1/upload/works/status.json", options)
      end
    end
  end
end
