module PixivApi
  class Response
    class Friend < Identity
      attr_reader :id, :account, :user_id, :name

      define_blob_method :profile_image_urls

      def initialize(response, attributes)
        user_id = attributes['user'].delete('id')

        merged = attributes['user'].merge(
          id: attributes['id'],
          user_id: user_id
        )

        super(response, merged)
      end

      def avatar_url
        blob_profile_image_urls['px_50x50']
      end
      memoize(:avatar_url)
    end
  end
end
